﻿/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2012 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

using System;
using System.Net;

namespace SeriTile
{
    public class Observable
    {
        public delegate void OnUpdateHandler(Observable sender, EventArgs eventArgs);
        public OnUpdateHandler OnUpdate;

        protected void Update()
        {
            if(OnUpdate != null)
                OnUpdate(this, new EventArgs());
        }

        protected void Update(EventArgs args)
        {
            if (OnUpdate != null)
                OnUpdate(this, args);
        }
    }
}
