﻿/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2012 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

using System;
using System.Net;
using System.Collections.Generic;

namespace SeriTile
{
    internal class AStarQueue
    {

	    System.Collections.Generic.List<PathMapTile> m_heap = new List<PathMapTile>();

        public PathMapTile pop()
	    {
            if(m_heap.Count == 0)
                return null;
		    PathMapTile tile= m_heap[0];
            m_heap[0] = m_heap[m_heap.Count-1];
		    m_heap.RemoveAt(m_heap.Count-1);
		    m_heap.Sort(new PathMapTile.Sorter());

		    return tile;
	    }

        public void push(PathMapTile tile)
	    {
		    m_heap.Add(tile);
		    m_heap.Sort(new PathMapTile.Sorter());
	    }

        public void update(PathMapTile element)
	    {
            int i=0;
            foreach(PathMapTile tile in m_heap)
            {
                if(tile.x == element.x && tile.y == element.y)
                {
                    if (i >= m_heap.Count - 1)
                        return;
                    m_heap.Sort(i,m_heap.Count-i,new PathMapTile.Sorter());
                    return;
                }
                i++;
            }

	    }

	    public bool isEmpty()
	    {
		    return m_heap.Count==0;
	    }
    }
}
