﻿/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2012 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace SeriTile
{
    public abstract class IGameState
    {
        public abstract void LoadContent(GraphicsDevice graphicsDevice, ContentManager content);

        public abstract void Update(Microsoft.Xna.Framework.GameTime gameTime);

        // Returns the next state if the current state is done/exited.
        public abstract IGameState GetNextState();

        public abstract void UnloadContent();

        public abstract void Draw(Microsoft.Xna.Framework.GameTime gameTime);
    }
}
