﻿/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2012 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

using System;
using Microsoft.Xna.Framework;

namespace SeriTile
{
    public class MathCommon
    {
        private static Random m_random = new Random();

        private MathCommon()
        {
            // Add constructor logic here
        }

        public static Vector2 RotateVector2(Vector2 vector, float angleInRads)
        {
            float cosRadians = (float)Math.Cos(angleInRads);
            float sinRadians = (float)Math.Sin(angleInRads);

            vector = new Vector2(vector.X * cosRadians - vector.Y * sinRadians,
                                 vector.X * sinRadians + vector.Y * cosRadians);
            return vector;
        }

        public static float GetRandomValueVariance(float value, float variance)
        {
            return value + ((float)m_random.NextDouble()) * variance * 2 - variance;
        }

        public static Color GetRandomValueVariance(Color value, Color variance)
        {
            return new Color(value.R + m_random.Next(variance.R * 2) - variance.R,
                value.G + m_random.Next(variance.G * 2) - variance.G,
                value.B + m_random.Next(variance.B * 2) - variance.B,
                value.A + m_random.Next(variance.A * 2) - variance.A);
        }
    }
}
