﻿/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2012 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

using System;
using Microsoft.Xna.Framework;

namespace SeriTile
{
    public class PlanarParticleCollider:IParticleCollider
    {
        public enum ComparisonType { Greater, Lesser };
        public enum PlaneType { X, Y };

        public PlaneType Plane { get; set; }
        public ComparisonType Comparison { get; set; }
        public float Value { get; set; }

        public PlanarParticleCollider(float value, PlaneType plane, ComparisonType comparison)
        {
            Comparison = comparison;
            Plane = plane;
            Value = value;
        }

        public void Collide(Particle particle)
        {
            switch (Comparison)
            {
                case ComparisonType.Greater:
                    if ((Plane == PlaneType.Y && particle.Position.Y > Value) || (Plane == PlaneType.X && particle.Position.X > Value))
                        particle.Kill();
                    break;
                case ComparisonType.Lesser:
                    if ((Plane == PlaneType.Y && particle.Position.Y < Value) || (Plane == PlaneType.X && particle.Position.X < Value))
                        particle.Kill();
                    break;
            }
        }
        

    }
}
