﻿/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2012 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

using System;
using Microsoft.Xna.Framework;

namespace SeriTile
{
    public class EmitterRotateInitializer : IParticleInitializer
    {
        public float RotateRate { get; set; }
        public float Spread { get; set; }

        private Random m_random = new Random();
        private Vector2 m_currentDirection;

        public EmitterRotateInitializer(float rotateRate, float spread)
        {
            RotateRate = rotateRate;
            Spread = spread;

            m_currentDirection = new Vector2(1, 0);
      //      float angle = (float)m_random.NextDouble() * MathHelper.TwoPi;
      //      m_currentDirection.X += (float)(Math.Cos(angle - MathHelper.PiOver2));
      //      m_currentDirection.Y += (float)(Math.Sin(angle - MathHelper.PiOver2));
        }

        public void Initialize(Particle particle)
        {
            Vector2 direction = m_currentDirection;
            float angleSpread = ((float)m_random.NextDouble()) * Spread * 2 - Spread;
            direction = MathCommon.RotateVector2(direction, angleSpread);
            direction.Normalize();

            particle.Direction = direction;
        }

        public void Update(float deltaTime)
        {
            float angleChange = RotateRate * deltaTime;
            m_currentDirection = MathCommon.RotateVector2(m_currentDirection, angleChange);

        }
    }
}
